/*
calcfbrc.c
-------------------
CalcFabric
by mibi88
-------------------
25/07/2022
-------------------
Licence:GNU GPL v2
v.1.0a1
*/

#include "fxlib.h"
#include "stdio.h"
#include "stdlib.h"

#define EXIT 30002
#define EXE 30004
#define SHIFT 30006
#define F1 30009
#define F2 30010
#define F3 30011
#define F4 30012
#define F5 30013
#define F6 30014
#define UP 30018
#define DOWN 30023
#define LEFT 30020
#define RIGHT 30021

static void text(int x,int y,unsigned char* str){
 locate(x,y);
 Print(str);
}

static unsigned int key=0,game=0,s=0,sel=0,i,mod=0,design=0,hardware=0,makeselect=0, value, editing;
static int d=20000,modelsmkt[4],modelsprd[4],modelssls[4],modelssft[4],modelsqlt[4],modelsage[4],model[4];
static unsigned char* buffer[64];

static void drawmodels(){
 PrintMini(5,8,"Ma: Sls | Mkt | Prd | Sft | Hdw",0);
 for(i=0;i!=4;i++){
  sprintf(buffer,"M%d: %dm | %d | %dm | %dh | %dm",modelsage[i],modelssls[i]/1000,modelsmkt[i],modelsprd[i]/1000,modelssft[i]/100,modelsqlt[i]/1000);
  PrintMini(5,i*7+15,buffer,0);
  if(i==sel){
   PrintMini(1,i*7+15,">",0);
  }
 }
}
static void drawmakenew(){
 PrintMini(1,9+makeselect*7,">",0);
 sprintf(buffer,"Design: <%d>",design);
 PrintMini(5,9,buffer,0);
 sprintf(buffer,"Hardware: <%d>",hardware);
 PrintMini(5,16,buffer,0);
}
void reset(){
 for(i=0;i!=4;i++){
  modelsmkt[i]=0;
  modelsprd[i]=0;
  modelssls[i]=0;
  modelssft[i]=0;
  modelsqlt[i]=0;
  modelsage[i]=0;
  model[i]=0;
 }
}
void gui(){ // Base GUI.
 sprintf(buffer,"s:%d  |  $:%d",s,d);
 PrintMini(1,1,buffer,0);
 PrintMini(1,56,"Nw | Stp | Prd |     | Mkt | Sft",0);
 PrintMini(1,45,"EXE/SHIFT to continue",0);
}

static int main(){
 Bdisp_AllClr_DDVRAM();
 reset();
 text(5,2,"CalcFabric");
 text(4,5,"EXE to play.");
 while(key!=EXIT){
  GetKey(&key);
  if(game==1){
   Bdisp_AllClr_DDVRAM();
   gui();
   if(key==UP&&sel>0){
    sel--;
   }else if(key==DOWN&&sel<3){
    sel++;
   }
   drawmodels();
   if(key==EXE){
    s=0;
    for(i=0;i!=4;i++){
     if(model[i]==1){
      modelssls[i]=((modelsmkt[i]/10+modelsqlt[i]/100)*(modelssft[i]/100))-modelsage[i]*100;
	  d-=modelsmkt[i];
	  d-=modelssft[i];
      if(modelsprd[i]<modelssls[i]){
       modelssls[i]=modelsprd[i];
      }
      if(modelssls[i]<0){
       modelssls[i]=0;
      }
      d+=modelssls[i]*10;
      s+=modelssls[i];
      modelsage[i]++;
     }
    }
   }else if(key==F1){
    for(i=0;i!=4;i++){
     if(model[i]==0){
      mod=i;
      game=2;
      break;
     }
    }
   }else if(key==F2){
    modelsage[i]=0;
    modelssls[i]=0;
    modelsmkt[i]=0;
    modelsprd[i]=0;
    modelssft[i]=0;
    modelsqlt[i]=0;
    model[sel]=0;
   }else if(key==F3){
    editing=1;
    game=3;
	value=0;
   }else if(key==F5){
    editing=2;
    game=3;
	value=0;
   }else if(key==F6){
    editing=3;
    game=3;
	value=0;
   }
   if(d<0){
    game=4;
   }
  }else if(game==2){
   Bdisp_AllClr_DDVRAM();
   gui();
   drawmakenew();
   if(key==UP&&makeselect==1){
    makeselect=0;
   }else if(key==DOWN&&makeselect==0){
    makeselect=1;
   }else if(key==LEFT){
    if(makeselect==0&&design>0){
     design-=100;
    }else if(makeselect==1&&design>0){
     hardware-=100;
    }
   }else if(key==RIGHT){
    if(makeselect==0&&design<d){
     design+=100;
    }else if(makeselect==1&&design<d){
     hardware+=100;
    }
   }else if(key==SHIFT){
    if(d>=design+hardware&&design+hardware>0){
     modelsqlt[mod]=design+hardware;
     d-=design+hardware;
     model[mod]=1;
     game=1;
    }
   }
  }else if(game==3){
   Bdisp_AllClr_DDVRAM();
   gui();
   sprintf(buffer,"Value: <%d>",value);
   PrintMini(5,9,buffer,0);
   if(value>0&&key==LEFT){
    value-=50;
   }else if(value<d&&key==RIGHT){
    value+=50;
   }else if(key==SHIFT){
    if(model[sel]==1){
     if(editing==1){
      modelsprd[sel]=value;
     }else if(editing==2){
      modelsmkt[sel]=value;
     }else if(editing==3){
      modelssft[sel]=value;
     }
	}
    game=1;
   }
  }else if(game==4){
   Bdisp_AllClr_DDVRAM();
   gui();
   text(1, 2, "GAME OVER");
   text(1, 3, "You went bankrupt.");
   text(1, 4, "EXIT to quit.");
   text(1, 5, "EXE to restart.");
   if(key==EXE){
    game=0;
    reset();
   }
  }
  if(game==0){
   text(5,2,"CalcFabric");
   text(4,5,"EXE to play.");
  }
  if(game==0){
   if(key==EXE){
    game=1;
   }
  }
  key=0;
 }
 return 1;
}
int AddIn_main(int isAppli, unsigned short OptionNum){
 return main();
}
//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section